package dsnserver;

import java.sql.ResultSet;
import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;

/**********************************************
 * NOT USED YET!
 * A function which is used as a XmlRpc function.
 * It is used for sending out a target command
 * and to send the reply back to the GUI. 
 *
 * @author kaltt
 * 
 **********************************************/
public class XmlRpcTargetCommand_CmdID extends Thread{

	Communication myComm;
	
	public XmlRpcTargetCommand_CmdID(Communication comm) {
		myComm = comm;
	}

	
	/**********************************************
	* A function which is used as a XmlRpc function.
	* It is used for sending out a target command
	* and to send the reply back to the GUI.
	* 
	* The replies are stored in a DB table, this 
	* will be done from the class 
	* CmdParserTargetCommand.
	* 
	* It regularly it looks if the timeout is over
	* or if the number of stored replies in the DB
	* is equal or grater than maxreply. In this 
	* case the replies will be sent back.
	* 
	* @param String DSNID<br>
	* String command (the command that will be 
	* sent to the Target)<br>
	* long timeout (the time we will wait before 
	* sending back the replies)<br>
	* int maxreply (the number of replies we are 
	* waiting for)
	* 
	* @return Vector targetCommand (Hashtable: 
	* Key: (DSNID, cmdReply))
	**********************************************/
	public  Vector targetCommand(String DSNID, String command, long timeout, int maxreply) throws Exception{
		
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,Object> t;
		
        if (DSNID.equals("all")){DSNID = "00:00:00:00:00:00";}

		SQLDBcommunication.lock();
		ResultSet result_sql = SQLDBcommunication.getResultsFromDB("" +
				"SELECT `cmdID` FROM `cmdReply` ORDER BY `cmdID` DESC LIMIT 0 , 1");
		result_sql.next();
		SQLDBcommunication.unlock();
		int cmdID = Integer.parseInt(result_sql.getString("cmdID")) + 1;

		myComm.lock();
        myComm.writeLine("rpcs " + DSNID + " tcmd " + cmdID + " " + command);
		myComm.unlock();
        
//while alle antworten da, zeit vorbei
    	Date endTime = new Date();
    	Date now;
    	long endTime_l = endTime.getTime() + timeout;
        int num = 0;
        do{
        	sleep(250);
			SQLDBcommunication.lock();
    		ResultSet result_c = SQLDBcommunication.getResultsFromDB("" +
    				"SELECT * FROM `cmdReply` WHERE cmdID = '" + cmdID + "';");
    		num = result_c.getFetchSize();        	
			SQLDBcommunication.unlock();
        	now = new Date();        	
        }while ((now.getTime() >= endTime_l) || (num >= maxreply && maxreply != 0));
        
		SQLDBcommunication.lock();
        result_sql = SQLDBcommunication.getResultsFromDB("" +
				"SELECT * FROM `cmdReply` WHERE cmdID = '" + cmdID + "';");
		while (result_sql.next()) 
		{  
			t = new Hashtable<String,Object>();
			t.put("DSNID", new String(result_sql.getString("DSNID")));
			t.put("cmdReply", new String(result_sql.getString("cmdReply")));
			result.add(t);
		}
		SQLDBcommunication.unlock();
		
		return result;
	}

	
	/**********************************************
	* This function is not waiting for a maxrepy 
	* amount. The result is sent back after the 
	* timeout.
	* (	result = targetCommand(DSNID, command, timeout, 0);
	*   return result;)  
	*   	
	* @param String DSNID<br>
	* String command (the command that will be 
	* sent to the Target)<br>
	* long timeout (the time we will wait before 
	* sending back the replies)<br>
	* 
	* @return Vector targetCommand (Hashtable: 
	* Key: (DSNID, cmdReply))
	**********************************************/
	@SuppressWarnings("unchecked")
	public  Vector targetCommand(String DSNID, String command, long timeout) throws Exception{
		Vector<Hashtable> result = new Vector<Hashtable>();
		result = targetCommand(DSNID, command, timeout, 0);
		return result;
	}
}

//-- 
//-- Table structure for table `cmdreply`
//-- 
//
//CREATE TABLE `cmdreply` (
//  `ID` int(11) NOT NULL auto_increment,
//  `cmdID` int(11) NOT NULL,
//  `DSNID` varchar(17) collate latin1_general_ci NOT NULL,
//  `cmdReply` text collate latin1_general_ci NOT NULL,
//  PRIMARY KEY  (`ID`)
//) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=9 ;


