package dsnserver;
/**********************************************
 * An interface which is used by the classes 
 * which are responsible for the communication 
 * between DSNServer and DSNnode .
 *  
 * @author kaltt
 *
 **********************************************/
public interface Communication {
	public void open(String Name);
	public void close();
	public String readLine();
	public void writeLine(String command);
	public void deleteLog();
	public void lock();
	public void unlock();
}
